( function ( $ ) {
	$(
		function () {
				var site_base_url = window.location.origin;

				// Authorization
				$( '#spreadsheet_authorize_btn' ).click(
					function ( e ) {
						e.preventDefault();
						var authUrl = $( this ).attr( 'href' );
						if ( authUrl == '' ) {
							alert( 'Please add and save Client ID and Client Secret first.' )
							return false;
						}
						var win       = window.open( authUrl, "nfspreadsheetauthwindow", 'width=1000, height=600' );
						var pollTimer = window.setInterval(
							function () {
								try {
									if ( win.document.URL.indexOf( site_base_url ) != -1 ) {
										window.clearInterval( pollTimer );
										var response_url = win.document.URL;
										var auth_code    = nf_spreadsheet_gup( response_url, 'code' );
										win.close();
										// We don't have an access token yet, have to go to the server for it
										var data = {
											action: 'nf_spreadsheet_finish_code_exchange',
											auth_code: decodeURIComponent( auth_code )
										};
										$.post(
											ajaxurl, data, function ( response ) {
												alert( 'Authorization Successful, please wait while page is reloading.' )
												location.reload();
											}
										);
									}
								} catch ( e ) {
								}
							}, 500
						);
					}
				)

				$( '#spreadsheet_revoke_btn' ).click(
					function ( e ) {
						e.preventDefault();
						var data = {
							action: 'nf_spreadsheet_revoke',
						};
						$.post(
							ajaxurl, data, function ( response ) {
								alert( 'Tokens revoked successfully' )
								// console.log(response);
								location.reload();
							}
						);
					}
				)

				$( 'body' ).on(
					'click', '#ninjaforms_google_spreadsheet_clear_cache_btn', function( event ) {
						event.preventDefault();
						data = {
							action: 'clear_nf_googlespreadsheet_cache',
						};
						$.post(
							ajaxurl, data, function( result ) {
								location.reload();
							}
						);
					}
				);

		}
	);
} )( jQuery );

// helper function to parse out the query string params
function nf_spreadsheet_gup( url, name ) {
	name        = name.replace( /[\[]/, "\\\[" ).replace( /[\]]/, "\\\]" );
	var regexS  = "[\\?#&]" + name + "=([^&#]*)";
	var regex   = new RegExp( regexS );
	var results = regex.exec( url );
	if ( results == null ) {
		return "";
	} else {
		return results[ 1 ];
	}
}
